package ciss.phase_viewer.atomcoord.pmodel;

final class GeneratorList {
    private static final GeneratorList instance = new GeneratorList();
    private Generator list[];

    public static void main(String[] args) {
        Generator gene;

        gene = instance.getGenerator(1);

        System.out.println(gene);
        // System.out.println(getNumOfGenerator(0));
        System.out.println(getNumOfChoice(1));
        System.out.println(getNumOfChoice(227));
        System.out.println(getNumOfChoice(7));
    }

    private GeneratorList() {
        list = new Generator[230 + 1]; // from 1 to 230

        list[0] = null;
        list[1] = new Generator("P1", new String[][] { {} });
        list[2] = new Generator("P-1", new String[][] { { "-x,-y,-z" } });
        list[3] = new Generator("P2", new String[][] { { "-x,y,-z" } });
        list[4] = new Generator("P2_1", new String[][] { { "-x,1/2+y,-z" } });
        list[5] = new Generator("C2", new String[][] { { "-x,y,-z" } });
        list[6] = new Generator("Pm", new String[][] { { "x,-y,z" } });
        list[7] = new Generator("Pc", new String[][] { { "x,-y,1/2+z" },
                { "1/2+x,-y,1/2+z" }, { "1/2+x,-y,z" } });
        list[8] = new Generator("Cm", new String[][] { { "x,-y,z" } });
        list[9] = new Generator("Cc", new String[][] { { "x,-y,1/2+z" } });
        list[10] = new Generator("P2/m", new String[][] { { "-x,y,-z",
                "-x,-y,-z" } });
        list[11] = new Generator("P2_1/m", new String[][] { { "-x,1/2+y,-z",
                "-x,-y,-z" } });
        list[12] = new Generator("C2/m", new String[][] { { "-x,y,-z",
                "-x,-y,-z" } });
        list[13] = new Generator("P2/c", new String[][] { { "-x,y,1/2-z",
                "-x,-y,-z" } });
        list[14] = new Generator("P2_1/c", new String[][] { { "-x,1/2+y,1/2-z",
                "-x,-y,-z" } });
        list[15] = new Generator("C2/c", new String[][] { { "-x,y,1/2-z",
                "-x,-y,-z" } });
        list[16] = new Generator("P222", new String[][] { { "-x,-y,z",
                "-x,y,-z" } });
        list[17] = new Generator("P222_1", new String[][] { { "-x,-y,1/2+z",
                "-x,y,1/2-z" } });
        list[18] = new Generator("P2_12_12", new String[][] { { "-x,-y,z",
                "1/2-x,y,1/2-z" } });
        list[19] = new Generator("P2_12_12_1", new String[][] { {
                "1/2-x,-y,1/2+z", "-x,1/2+y,1/2-z" } });
        list[20] = new Generator("C222_1", new String[][] { { "-x,-y,1/2+z",
                "-x,y,1/2-z" } });
        list[21] = new Generator("C222", new String[][] { { "-x,-y,z",
                "-x,y,-z" } });
        list[22] = new Generator("F222", new String[][] { { "-x,-y,z",
                "-x,y,-z" } });
        list[23] = new Generator("I222", new String[][] { { "-x,-y,z",
                "-x,y,-z" } });
        list[24] = new Generator("I2_12_12_1", new String[][] { {
                "1/2-x,-y,1/2+z", "-x,1/2+y,1/2-z" } });
        list[25] = new Generator("Pmm2",
                new String[][] { { "-x,-y,z", "x,-y,z" } });
        list[26] = new Generator("Pmc2_1", new String[][] { { "-x,-y,1/2+z",
                "x,-y,1/2+z" } });
        list[27] = new Generator("Pcc2", new String[][] { { "-x,-y,z",
                "x,1/2-y,z" } });
        list[28] = new Generator("Pma2", new String[][] { { "-x,-y,z",
                "1/2+x,-y,z" } });
        list[29] = new Generator("Pca2_1", new String[][] { { "-x,-y,1/2+z",
                "1/2+x,-y,z" } });
        list[30] = new Generator("Pnc2", new String[][] { { "-x,-y,z",
                "x,1/2-y,1/2+z" } });
        list[31] = new Generator("Pmn2_1", new String[][] { { "1/2-x,-y,1/2+z",
                "1/2+x,-y,1/2+z" } });
        list[32] = new Generator("Pba2", new String[][] { { "-x,-y,z",
                "1/2+x,1/2-y,z" } });
        list[33] = new Generator("Pna2_1", new String[][] { { "-x,-y,1/2+z",
                "1/2+x,1/2-y,z" } });
        list[34] = new Generator("Pnn2", new String[][] { { "-x,-y,z",
                "1/2+x,1/2-y,1/2+z" } });
        list[35] = new Generator("Cmm2",
                new String[][] { { "-x,-y,z", "x,-y,z" } });
        list[36] = new Generator("Cmc2_1", new String[][] { { "-x,-y,1/2+z",
                "x,-y,1/2+z" } });
        list[37] = new Generator("Ccc2", new String[][] { { "-x,-y,z",
                "x,-y,1/2+z" } });
        list[38] = new Generator("Amm2",
                new String[][] { { "-x,-y,z", "x,-y,z" } });
        list[39] = new Generator("Aem2", new String[][] { { "-x,-y,z",
                "x,1/2-y,z" } });
        list[40] = new Generator("Ama2", new String[][] { { "-x,-y,z",
                "1/2+x,-y,z" } });
        list[41] = new Generator("Aea2", new String[][] { { "-x,-y,z",
                "1/2+x,1/2-y,z" } });
        list[42] = new Generator("Fmm2",
                new String[][] { { "-x,-y,z", "x,-y,z" } });
        list[43] = new Generator("Fdd2", new String[][] { { "-x,-y,z",
                "1/4+x,1/4-y,1/4+z" } });
        list[44] = new Generator("Imm2",
                new String[][] { { "-x,-y,z", "x,-y,z" } });
        list[45] = new Generator("Iba2", new String[][] { { "-x,-y,z",
                "1/2+x,1/2-y,z" } });
        list[46] = new Generator("Ima2", new String[][] { { "-x,-y,z",
                "1/2+x,-y,z" } });
        list[47] = new Generator("Pmmm", new String[][] { { "-x,-y,z",
                "-x,y,-z", "-x,-y,-z" } });
        list[48] = new Generator("Pnnn", new String[][] {
                { "-x,-y,z", "-x,y,-z", "1/2-x,1/2-y,1/2-z" },
                { "1/2-x,1/2-y,z", "1/2-x,y,1/2-z", "-x,-y,-z" } });
        list[49] = new Generator("Pccm", new String[][] { { "-x,-y,z",
                "-x,y,1/2-z", "-x,-y,-z" } });
        list[50] = new Generator("Pban", new String[][] {
                { "-x,-y,z", "-x,y,-z", "1/2-x,1/2-y,-z" },
                { "1/2-x,1/2-y,z", "1/2-x,y,-z", "-x,-y,-z" } });
        list[51] = new Generator("Pmma", new String[][] { { "1/2-x,-y,z",
                "-x,y,-z", "-x,-y,-z" } });
        list[52] = new Generator("Pnna", new String[][] { { "1/2-x,-y,z",
                "1/2-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[53] = new Generator("Pmna", new String[][] { { "1/2-x,-y,1/2+z",
                "1/2-x,y,1/2-z", "-x,-y,-z" } });
        list[54] = new Generator("Pcca", new String[][] { { "1/2-x,-y,z",
                "-x,y,1/2-z", "-x,-y,-z" } });
        list[55] = new Generator("Pbam", new String[][] { { "-x,-y,z",
                "1/2-x,1/2+y,-z", "-x,-y,-z" } });
        list[56] = new Generator("Pccn", new String[][] { { "1/2-x,1/2-y,z",
                "-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[57] = new Generator("Pbcm", new String[][] { { "-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[58] = new Generator("Pnnm", new String[][] { { "-x,-y,z",
                "1/2-x,y,1/2-z", "-x,-y,-z" } });
        list[59] = new Generator("Pmmn", new String[][] {
                { "-x,-y,z", "1/2-x,1/2+y,-z", "1/2-x,1/2-y,-z" },
                { "1/2-x,1/2-y,z", "-x,1/2+y,-z", "-x,-y,-z" } });
        list[60] = new Generator("Pbcn", new String[][] { {
                "1/2-x,1/2-y,1/2+z", "-x,y,1/2-z", "-x,-y,-z" } });
        list[61] = new Generator("Pbca", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[62] = new Generator("Pnma", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,-z", "-x,-y,-z" } });
        list[63] = new Generator("Cmcm", new String[][] { { "-x,-y,1/2+z",
                "-x,y,1/2-z", "-x,-y,-z" } });
        list[64] = new Generator("Cmce", new String[][] { { "-x,1/2-y,1/2+z",
                "-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[65] = new Generator("Cmmm", new String[][] { { "-x,-y,z",
                "-x,y,-z", "-x,-y,-z" } });
        list[66] = new Generator("Cccm", new String[][] { { "-x,-y,z",
                "-x,y,1/2-z", "-x,-y,-z" } });
        list[67] = new Generator("Cmme", new String[][] { { "-x,1/2-y,z",
                "-x,1/2+y,-z", "-x,-y,-z" } });
        list[68] = new Generator("Ccce", new String[][] {
                { "1/2-x,1/2-y,z", "-x,y,-z", "-x,1/2-y,1/2-z" },
                { "1/2-x,-y,z", "-x,y,1/2-z", "-x,-y,-z" } });
        list[69] = new Generator("Fmmm", new String[][] { { "-x,-y,z",
                "-x,y,-z", "-x,-y,-z" } });
        list[70] = new Generator("Fddd", new String[][] {
                { "-x,-y,z", "-x,y,-z", "1/4-x,1/4-y,1/4-z" },
                { "3/4-x,3/4-y,z", "3/4-x,y,3/4-z", "-x,-y,-z" } });
        list[71] = new Generator("Immm", new String[][] { { "-x,-y,z",
                "-x,y,-z", "-x,-y,-z" } });
        list[72] = new Generator("Ibam", new String[][] { { "-x,-y,z",
                "1/2-x,1/2+y,-z", "-x,-y,-z" } });
        list[73] = new Generator("Ibca", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[74] = new Generator("Imma", new String[][] { { "-x,1/2-y,z",
                "-x,1/2+y,-z", "-x,-y,-z" } });
        list[75] = new Generator("P4", new String[][] { { "-y,x,z" } });
        list[76] = new Generator("P4_1", new String[][] { { "-y,x,1/4+z" } });
        list[77] = new Generator("P4_2", new String[][] { { "-y,x,1/2+z" } });
        list[78] = new Generator("P4_3", new String[][] { { "-y,x,3/4+z" } });
        list[79] = new Generator("I4", new String[][] { { "-y,x,z" } });
        list[80] = new Generator("I4_1",
                new String[][] { { "-y,1/2+x,1/4+z" } });
        list[81] = new Generator("P-4", new String[][] { { "y,-x,-z" } });
        list[82] = new Generator("I-4", new String[][] { { "y,-x,-z" } });
        list[83] = new Generator("P4/m", new String[][] { { "-y,x,z",
                "-x,-y,-z" } });
        list[84] = new Generator("P4_2/m", new String[][] { { "-y,x,1/2+z",
                "-x,-y,-z" } });
        list[85] = new Generator("P4/n", new String[][] {
                { "1/2-y,1/2+x,z", "1/2-x,1/2-y,-z" },
                { "1/2-y,x,z", "-x,-y,-z" } });
        list[86] = new Generator("P4_2/n", new String[][] {
                { "1/2-y,1/2+x,1/2+z", "1/2-x,1/2-y,1/2-z" },
                { "-y,1/2+x,1/2+z", "-x,-y,-z" } });
        list[87] = new Generator("I4/m", new String[][] { { "-y,x,z",
                "-x,-y,-z" } });
        list[88] = new Generator("I4_1/a", new String[][] {
                { "-y,1/2+x,1/4+z", "-x,1/2-y,1/4-z" },
                { "3/4-y,1/4+x,1/4+z", "-x,-y,-z" } });
        list[89] = new Generator("P422",
                new String[][] { { "-y,x,z", "-x,y,-z" } });
        list[90] = new Generator("P42_12", new String[][] { { "1/2-y,1/2+x,z",
                "1/2-x,1/2+y,-z" } });
        list[91] = new Generator("P4_122", new String[][] { { "-y,x,1/4+z",
                "-x,y,-z" } });
        list[92] = new Generator("P4_12_12", new String[][] { {
                "1/2-y,1/2+x,1/4+z", "1/2-x,1/2+y,1/4-z" } });
        list[93] = new Generator("P4_222", new String[][] { { "-y,x,1/2+z",
                "-x,y,-z" } });
        list[94] = new Generator("P4_22_12", new String[][] { {
                "1/2-y,1/2+x,1/2+z", "1/2-x,1/2+y,1/2-z" } });
        list[95] = new Generator("P4_322", new String[][] { { "-y,x,3/4+z",
                "-x,y,-z" } });
        list[96] = new Generator("P4_32_12", new String[][] { {
                "1/2-y,1/2+x,3/4+z", "1/2-x,1/2+y,3/4-z" } });
        list[97] = new Generator("I422",
                new String[][] { { "-y,x,z", "-x,y,-z" } });
        list[98] = new Generator("I4_122", new String[][] { { "-y,1/2+x,1/4+z",
                "1/2-x,y,3/4-z" } });
        list[99] = new Generator("P4mm",
                new String[][] { { "-y,x,z", "x,-y,z" } });
        list[100] = new Generator("P4bm", new String[][] { { "-y,x,z",
                "1/2+x,1/2-y,z" } });
        list[101] = new Generator("P4_2cm", new String[][] { { "-y,x,1/2+z",
                "x,-y,1/2+z" } });
        list[102] = new Generator("P4_2nm", new String[][] { {
                "1/2-y,1/2+x,1/2+z", "1/2+x,1/2-y,1/2+z" } });
        list[103] = new Generator("P4cc", new String[][] { { "-y,x,z",
                "x,-y,1/2+z" } });
        list[104] = new Generator("P4nc", new String[][] { { "-y,x,z",
                "1/2+x,1/2-y,1/2+z" } });
        list[105] = new Generator("P4_2mc", new String[][] { { "-y,x,1/2+z",
                "x,-y,z" } });
        list[106] = new Generator("P4_2bc", new String[][] { { "-y,x,1/2+z",
                "1/2+x,1/2-y,z" } });
        list[107] = new Generator("I4mm",
                new String[][] { { "-y,x,z", "x,-y,z" } });
        list[108] = new Generator("I4cm", new String[][] { { "-y,x,z",
                "x,-y,1/2+z" } });
        list[109] = new Generator("I4_1md", new String[][] { {
                "-y,1/2+x,1/4+z", "x,-y,z" } });
        list[110] = new Generator("I4_1cd", new String[][] { {
                "-y,1/2+x,1/4+z", "x,-y,1/2+z" } });
        list[111] = new Generator("P-42m", new String[][] { { "y,-x,-z",
                "-x,y,-z" } });
        list[112] = new Generator("P-42c", new String[][] { { "y,-x,-z",
                "-x,y,1/2-z" } });
        list[113] = new Generator("P-42_1m", new String[][] { { "y,-x,-z",
                "1/2-x,1/2+y,-z" } });
        list[114] = new Generator("P-42_1c", new String[][] { { "y,-x,-z",
                "1/2-x,1/2+y,1/2-z" } });
        list[115] = new Generator("P-4m2", new String[][] { { "y,-x,-z",
                "x,-y,z" } });
        list[116] = new Generator("P-4c2", new String[][] { { "y,-x,-z",
                "x,-y,1/2+z" } });
        list[117] = new Generator("P-4b2", new String[][] { { "y,-x,-z",
                "1/2+x,1/2-y,z" } });
        list[118] = new Generator("P-4n2", new String[][] { { "y,-x,-z",
                "1/2+x,1/2-y,1/2+z" } });
        list[119] = new Generator("I-4m2", new String[][] { { "y,-x,-z",
                "x,-y,z" } });
        list[120] = new Generator("I-4c2", new String[][] { { "y,-x,-z",
                "x,-y,1/2+z" } });
        list[121] = new Generator("I-42m", new String[][] { { "y,-x,-z",
                "-x,y,-z" } });
        list[122] = new Generator("I-42d", new String[][] { { "y,-x,-z",
                "1/2-x,y,3/4-z" } });
        list[123] = new Generator("P4/mmm", new String[][] { { "-y,x,z",
                "-x,y,-z", "-x,-y,-z" } });
        list[124] = new Generator("P4/mcc", new String[][] { { "-y,x,z",
                "-x,y,1/2-z", "-x,-y,-z" } });
        list[125] = new Generator("P4/nbm", new String[][] {
                { "-y,x,z", "-x,y,-z", "1/2-x,1/2-y,-z" },
                { "1/2-y,x,z", "1/2-x,y,-z", "-x,-y,-z" } });
        list[126] = new Generator("P4/nnc", new String[][] {
                { "-y,x,z", "-x,y,-z", "1/2-x,1/2-y,1/2-z" },
                { "1/2-y,x,z", "1/2-x,y,1/2-z", "-x,-y,-z" } });
        list[127] = new Generator("P4/mbm", new String[][] { { "-y,x,z",
                "1/2-x,1/2+y,-z", "-x,-y,-z" } });
        list[128] = new Generator("P4/mnc", new String[][] { { "-y,x,z",
                "1/2-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[129] = new Generator("P4/nmm", new String[][] {
                { "1/2-y,1/2+x,z", "1/2-x,1/2+y,-z", "1/2-x,1/2-y,-z" },
                { "1/2-y,x,z", "-x,1/2+y,-z", "-x,-y,-z" } });
        list[130] = new Generator("P4/ncc",
                new String[][] {
                        { "-x,-y,z", "1/2-y,1/2+x,z", "1/2-x,1/2+y,1/2-z",
                                "1/2-x,1/2-y,-z" },
                        { "1/2-x,1/2-y,z", "1/2-y,x,z", "-x,1/2+y,1/2-z",
                                "-x,-y,-z" } });
        list[131] = new Generator("P4_2/mmc", new String[][] { { "-x,-y,z",
                "-y,x,1/2+z", "-x,y,-z", "-x,-y,-z" } });
        list[132] = new Generator("P4_2/mcm", new String[][] { { "-x,-y,z",
                "-y,x,1/2+z", "-x,y,1/2-z", "-x,-y,-z" } });
        list[133] = new Generator("P4_2/nbc",
                new String[][] {
                        { "-x,-y,z", "1/2-y,1/2+x,1/2+z", "-x,y,1/2-z",
                                "1/2-x,1/2-y,1/2-z" },
                        { "1/2-x,1/2-y,z", "1/2-y,x,1/2+z", "1/2-x,y,-z",
                                "-x,-y,-z" } });
        list[134] = new Generator("P4_2/nnm",
                new String[][] {
                        { "-x,-y,z", "1/2-y,1/2+x,1/2+z", "-x,y,-z",
                                "1/2-x,1/2-y,1/2-z" },
                        { "1/2-x,1/2-y,z", "1/2-y,x,1/2+z", "1/2-x,y,1/2-z",
                                "-x,-y,-z" } });
        list[135] = new Generator("P4_2/mbc", new String[][] { { "-x,-y,z",
                "-y,x,1/2+z", "1/2-x,1/2+y,-z", "-x,-y,-z" } });
        list[136] = new Generator("P4_2/mnm", new String[][] { { "-x,-y,z",
                "1/2-y,1/2+x,1/2+z", "1/2-x,1/2+y,1/2-z", "-x,-y,-z" } });
        list[137] = new Generator("P4_2/nmc",
                new String[][] {
                        { "-x,-y,z", "1/2-y,1/2+x,1/2+z", "1/2-x,1/2+y,1/2-z",
                                "1/2-x,1/2-y,1/2-z" },
                        { "1/2-x,1/2-y,z", "1/2-y,x,1/2+z", "-x,1/2+y,-z",
                                "-x,-y,-z" } });
        list[138] = new Generator("P4_2/ncm", new String[][] {
                { "-x,-y,z", "1/2-y,1/2+x,1/2+z", "1/2-x,1/2+y,-z",
                        "1/2-x,1/2-y,1/2-z" },
                { "1/2-x,1/2-y,z", "1/2-y,x,1/2+z", "-x,1/2+y,1/2-z",
                        "-x,-y,-z" } });
        list[139] = new Generator("I4/mmm", new String[][] { { "-x,-y,z",
                "-y,x,z", "-x,y,-z", "-x,-y,-z" } });
        list[140] = new Generator("I4/mcm", new String[][] { { "-x,-y,z",
                "-y,x,z", "-x,y,1/2-z", "-x,-y,-z" } });
        list[141] = new Generator("I4_1/amd", new String[][] {
                { "1/2-x,1/2-y,1/2+z", "-y,1/2+x,1/4+z", "1/2-x,y,3/4-z",
                        "-x,1/2-y,1/4-z" },
                { "1/2-x,-y,1/2+z", "1/4-y,3/4+x,1/4+z", "1/2-x,y,1/2-z",
                        "-x,-y,-z" } });
        list[142] = new Generator("I4_1/acd", new String[][] {
                { "1/2-x,1/2-y,1/2+z", "-y,1/2+x,1/4+z", "1/2-x,y,1/4-z",
                        "-x,1/2-y,1/4-z" },
                { "1/2-x,-y,1/2+z", "1/4-y,3/4+x,1/4+z", "1/2-x,y,-z",
                        "-x,-y,-z" } });
        list[143] = new Generator("P3", new String[][] { { "-y,x-y,z" } });
        list[144] = new Generator("P3_1", new String[][] { { "-y,x-y,1/3+z" } });
        list[145] = new Generator("P3_2", new String[][] { { "-y,x-y,2/3+z" } });
        list[146] = new Generator("R3", new String[][] { { "-y,x-y,z" } });
        list[147] = new Generator("P-3", new String[][] { { "-y,x-y,z",
                "-x,-y,-z" } });
        list[148] = new Generator("R-3", new String[][] { { "-y,x-y,z",
                "-x,-y,-z" } });
        list[149] = new Generator("P312", new String[][] { { "-y,x-y,z",
                "-y,-x,-z" } });
        list[150] = new Generator("P321", new String[][] { { "-y,x-y,z",
                "y,x,-z" } });
        list[151] = new Generator("P3_112", new String[][] { { "-y,x-y,1/3+z",
                "-y,-x,2/3-z" } });
        list[152] = new Generator("P3_121", new String[][] { { "-y,x-y,1/3+z",
                "y,x,-z" } });
        list[153] = new Generator("P3_212", new String[][] { { "-y,x-y,2/3+z",
                "-y,-x,1/3-z" } });
        list[154] = new Generator("P3_221", new String[][] { { "-y,x-y,2/3+z",
                "y,x,-z" } });
        list[155] = new Generator("R32", new String[][] { { "-y,x-y,z",
                "y,x,-z" } });
        list[156] = new Generator("P3m1", new String[][] { { "-y,x-y,z",
                "-y,-x,z" } });
        list[157] = new Generator("P31m", new String[][] { { "-y,x-y,z",
                "y,x,z" } });
        list[158] = new Generator("P3c1", new String[][] { { "-y,x-y,z",
                "-y,-x,1/2+z" } });
        list[159] = new Generator("P31c", new String[][] { { "-y,x-y,z",
                "y,x,1/2+z" } });
        list[160] = new Generator("R3m", new String[][] { { "-y,x-y,z",
                "-y,-x,z" } });
        list[161] = new Generator("R3c", new String[][] { { "-y,x-y,z",
                "-y,-x,1/2+z" } });
        list[162] = new Generator("P-31m", new String[][] { { "-y,x-y,z",
                "-y,-x,-z", "-x,-y,-z" } });
        list[163] = new Generator("P-31c", new String[][] { { "-y,x-y,z",
                "-y,-x,1/2-z", "-x,-y,-z" } });
        list[164] = new Generator("P-3m1", new String[][] { { "-y,x-y,z",
                "y,x,-z", "-x,-y,-z" } });
        list[165] = new Generator("P-3c1", new String[][] { { "-y,x-y,z",
                "y,x,1/2-z", "-x,-y,-z" } });
        list[166] = new Generator("R-3m", new String[][] { { "-y,x-y,z",
                "y,x,-z", "-x,-y,-z" } });
        list[167] = new Generator("R-3c", new String[][] { { "-y,x-y,z",
                "y,x,1/2-z", "-x,-y,-z" } });
        list[168] = new Generator("P6", new String[][] { { "-y,x-y,z",
                "-x,-y,z" } });
        list[169] = new Generator("P6_1", new String[][] { { "-y,x-y,1/3+z",
                "-x,-y,1/2+z" } });
        list[170] = new Generator("P6_5", new String[][] { { "-y,x-y,2/3+z",
                "-x,-y,1/2+z" } });
        list[171] = new Generator("P6_2", new String[][] { { "-y,x-y,2/3+z",
                "-x,-y,z" } });
        list[172] = new Generator("P6_4", new String[][] { { "-y,x-y,1/3+z",
                "-x,-y,z" } });
        list[173] = new Generator("P6_3", new String[][] { { "-y,x-y,z",
                "-x,-y,1/2+z" } });
        list[174] = new Generator("P-6", new String[][] { { "-y,x-y,z",
                "x,y,-z" } });
        list[175] = new Generator("P6/m", new String[][] { { "-y,x-y,z",
                "-x,-y,z", "-x,-y,-z" } });
        list[176] = new Generator("P6_3/m", new String[][] { { "-y,x-y,z",
                "-x,-y,1/2+z", "-x,-y,-z" } });
        list[177] = new Generator("P622", new String[][] { { "-y,x-y,z",
                "-x,-y,z", "y,x,-z" } });
        list[178] = new Generator("P6_122", new String[][] { { "-y,x-y,1/3+z",
                "-x,-y,1/2+z", "y,x,1/3-z" } });
        list[179] = new Generator("P6_522", new String[][] { { "-y,x-y,2/3+z",
                "-x,-y,1/2+z", "y,x,2/3-z" } });
        list[180] = new Generator("P6_222", new String[][] { { "-y,x-y,2/3+z",
                "-x,-y,z", "y,x,2/3-z" } });
        list[181] = new Generator("P6_422", new String[][] { { "-y,x-y,1/3+z",
                "-x,-y,z", "y,x,1/3-z" } });
        list[182] = new Generator("P6_322", new String[][] { { "-y,x-y,z",
                "-x,-y,1/2+z", "y,x,-z" } });
        list[183] = new Generator("P6mm", new String[][] { { "-y,x-y,z",
                "-x,-y,z", "-y,-x,z" } });
        list[184] = new Generator("P6cc", new String[][] { { "-y,x-y,z",
                "-x,-y,z", "-y,-x,1/2+z" } });
        list[185] = new Generator("P6_3cm", new String[][] { { "-y,x-y,z",
                "-x,-y,1/2+z", "-y,-x,1/2+z" } });
        list[186] = new Generator("P6_3mc", new String[][] { { "-y,x-y,z",
                "-x,-y,1/2+z", "-y,-x,z" } });
        list[187] = new Generator("P-6m2", new String[][] { { "-y,x-y,z",
                "x,y,-z", "-y,-x,z" } });
        list[188] = new Generator("P-6c2", new String[][] { { "-y,x-y,z",
                "x,y,1/2-z", "-y,-x,1/2+z" } });
        list[189] = new Generator("P-62m", new String[][] { { "-y,x-y,z",
                "x,y,-z", "y,x,-z" } });
        list[190] = new Generator("P-62c", new String[][] { { "-y,x-y,z",
                "x,y,1/2-z", "y,x,-z" } });
        list[191] = new Generator("P6/mmm", new String[][] { { "-y,x-y,z",
                "-x,-y,z", "y,x,-z", "-x,-y,-z" } });
        list[192] = new Generator("P6/mcc", new String[][] { { "-y,x-y,z",
                "-x,-y,z", "y,x,1/2-z", "-x,-y,-z" } });
        list[193] = new Generator("P6_3/mcm", new String[][] { { "-y,x-y,z",
                "-x,-y,1/2+z", "y,x,1/2-z", "-x,-y,-z" } });
        list[194] = new Generator("P6_3/mmc", new String[][] { { "-y,x-y,z",
                "-x,-y,1/2+z", "y,x,-z", "-x,-y,-z" } });
        list[195] = new Generator("P23", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y" } });
        list[196] = new Generator("F23", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y" } });
        list[197] = new Generator("I23", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y" } });
        list[198] = new Generator("P2_13", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "z,x,y" } });
        list[199] = new Generator("I2_13", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "z,x,y" } });
        list[200] = new Generator("Pm-3", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "-x,-y,-z" } });
        list[201] = new Generator("Pn-3", new String[][] {
                { "-x,-y,z", "-x,y,-z", "z,x,y", "1/2-x,1/2-y,1/2-z" },
                { "1/2-x,1/2-y,z", "1/2-x,y,1/2-z", "z,x,y", "-x,-y,-z" } });
        list[202] = new Generator("Fm-3", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "-x,-y,-z" } });
        list[203] = new Generator("Fd-3", new String[][] {
                { "-x,-y,z", "-x,y,-z", "z,x,y", "1/4-x,1/4-y,1/4-z" },
                { "3/4-x,3/4-y,z", "3/4-x,y,3/4-z", "z,x,y", "-x,-y,-z" } });
        list[204] = new Generator("Im-3", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "-x,-y,-z" } });
        list[205] = new Generator("Pa-3", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "z,x,y", "-x,-y,-z" } });
        list[206] = new Generator("Ia-3", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "z,x,y", "-x,-y,-z" } });
        list[207] = new Generator("P432", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,-z" } });
        list[208] = new Generator("P4_232", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "1/2+y,1/2+x,1/2-z" } });
        list[209] = new Generator("F432", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,-z" } });
        list[210] = new Generator("F4_132", new String[][] { {
                "-x,1/2-y,1/2+z", "1/2-x,1/2+y,-z", "z,x,y",
                "3/4+y,1/4+x,3/4-z" } });
        list[211] = new Generator("I432", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,-z" } });
        list[212] = new Generator("P4_332", new String[][] { {
                "1/2-x,-y,1/2+z", "-x,1/2+y,1/2-z", "z,x,y",
                "1/4+y,3/4+x,3/4-z" } });
        list[213] = new Generator("P4_132", new String[][] { {
                "1/2-x,-y,1/2+z", "-x,1/2+y,1/2-z", "z,x,y",
                "3/4+y,1/4+x,1/4-z" } });
        list[214] = new Generator("I4_132", new String[][] { {
                "1/2-x,-y,1/2+z", "-x,1/2+y,1/2-z", "z,x,y",
                "3/4+y,1/4+x,1/4-z" } });
        list[215] = new Generator("P-43m", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,z" } });
        list[216] = new Generator("F-43m", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,z" } });
        list[217] = new Generator("I-43m", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,z" } });
        list[218] = new Generator("P-43n", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "1/2+y,1/2+x,1/2+z" } });
        list[219] = new Generator("F-43c", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "1/2+y,1/2+x,1/2+z" } });
        list[220] = new Generator("I-43d", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "z,x,y", "1/4+y,1/4+x,1/4+z" } });
        list[221] = new Generator("Pm-3m", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,-z", "-x,-y,-z" } });
        list[222] = new Generator("Pn-3n",
                new String[][] {
                        { "-x,-y,z", "-x,y,-z", "z,x,y", "y,x,-z",
                                "1/2-x,1/2-y,1/2-z" },
                        { "1/2-x,1/2-y,z", "1/2-x,y,1/2-z", "z,x,y",
                                "y,x,1/2-z", "-x,-y,-z" } });
        list[223] = new Generator("Pm-3n", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "1/2+y,1/2+x,1/2-z", "-x,-y,-z" } });
        list[224] = new Generator("Pn-3m", new String[][] {
                { "-x,-y,z", "-x,y,-z", "z,x,y", "1/2+y,1/2+x,1/2-z",
                        "1/2-x,1/2-y,1/2-z" },
                { "1/2-x,1/2-y,z", "1/2-x,y,1/2-z", "z,x,y", "1/2+y,1/2+x,-z",
                        "-x,-y,-z" } });
        list[225] = new Generator("Fm-3m", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,-z", "-x,-y,-z" } });
        list[226] = new Generator("Fm-3c", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "1/2+y,1/2+x,1/2-z", "-x,-y,-z" } });
        list[227] = new Generator("Fd-3m", new String[][] {
                { "-x,1/2-y,1/2+z", "1/2-x,1/2+y,-z", "z,x,y",
                        "3/4+y,1/4+x,3/4-z", "1/4-x,1/4-y,1/4-z" },
                { "3/4-x,1/4-y,1/2+z", "1/4-x,1/2+y,3/4-z", "z,x,y",
                        "3/4+y,1/4+x,1/2-z", "-x,-y,-z" } });
        list[228] = new Generator("Fd-3c", new String[][] {
                { "-x,1/2-y,1/2+z", "1/2-x,1/2+y,-z", "z,x,y",
                        "3/4+y,1/4+x,3/4-z", "3/4-x,3/4-y,3/4-z" },
                { "1/4-x,3/4-y,1/2+z", "3/4-x,1/2+y,1/4-z", "z,x,y",
                        "3/4+y,1/4+x,-z", "-x,-y,-z" } });
        list[229] = new Generator("Im-3m", new String[][] { { "-x,-y,z",
                "-x,y,-z", "z,x,y", "y,x,-z", "-x,-y,-z" } });
        list[230] = new Generator("Ia-3d", new String[][] { { "1/2-x,-y,1/2+z",
                "-x,1/2+y,1/2-z", "z,x,y", "3/4+y,1/4+x,1/4-z", "-x,-y,-z" } });
    }

    static Generator getGenerator(int i) {
        return (instance.list)[i];
    }

    static int getNumOfChoice(int i) {
        return (instance.list)[i].getNumOfChoice();
    }

    /*
     * static int getNumOfGenerator(int i) { return
     * (instance.list)[i].getNumOfGenerator(); }
     */
}
