/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2006/12/12 15:51:48
!  AUTHOR(S): KOGA, Junichiro
!  File : Triclinic.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */
package ciss.phase_viewer.atomcoord.symmetry;

public class Triclinic extends BravaisLattice {
    private org.apache.log4j.Logger logger = org.apache.log4j.Logger
            .getLogger(Triclinic.class.getName());

    public String getName() {
        return "triclinic";
    }

    public double[][] getPrimitiveLatticeVector() {
        return getGenericPrimitiveVector();
    }

    protected boolean isThisForMe(double a, double b, double c, double alpha,
            double beta, double gamma) {
        if (!epsilonEquals(a, b) && !epsilonEquals(a, c)
                && !epsilonEquals(b, c) && !epsilonEquals(alpha, 90)
                && !epsilonEquals(beta, 90) && !epsilonEquals(gamma, 90))
            return true;
        return false;
    }

    public String[] getLatticeSystemCandidate() {
        return new String[] { PRIMITIVE };
    }

    protected BravaisLattice tryToCreateBravaisLattice(double[] avec,
            double[] bvec, double[] cvec) {
        if (!epsilonEquals(a, b) && !epsilonEquals(a, c)
                && !epsilonEquals(b, c) && !epsilonEquals(alpha, beta)
                && !epsilonEquals(alpha, gamma) && !epsilonEquals(beta, gamma))
            return this;
        return null;
    }

    public String getCrystalSystem() {
        return "triclinic";
    }

}
