/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2005/11/25, 15:09
!  AUTHOR(S): KOGA, Junichiro
!  File : SVGExporter.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.common;

import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;

import org.apache.batik.dom.GenericDOMImplementation;
import org.apache.batik.svggen.SVGGraphics2D;
import org.apache.log4j.Logger;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;

/**
 * uSVGv`̉摜GNX|[g.
 * 
 * @author
 */
public class SVGExporter {
    private static Logger logger = Logger
            .getLogger(SVGExporter.class.getName());

    /** Creates a new instance of SVGExporter */
    private SVGExporter() {
    }

    public static final void g2DtoSVG(Drawable draw, File file, int width,
            int height) throws IOException {
        g2DtoSVG(draw, new FileOutputStream(file), width, height);
    }

    public static final void g2DtoSVG(Drawable draw, OutputStream out,
            int width, int height) throws IOException {
        DOMImplementation domImpl = GenericDOMImplementation
                .getDOMImplementation();
        Document document = domImpl.createDocument(null, "svg", null);
        SVGGraphics2D svgGenerator = new SVGGraphics2D(document);
        svgGenerator.getGeneratorContext().setPrecision(6);
        draw.draw(svgGenerator, new Rectangle2D.Double(0, 0, width, height));
        Writer writer = new OutputStreamWriter(out, "UTF-8");
        svgGenerator.stream(writer, true);
    }

}
