/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2005/11/17, 17:10
!  AUTHOR(S): KOGA, Junichiro
!  File : DataSet.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.graph.dataset;

import java.util.Vector;

import org.apache.log4j.Logger;

/**
 * f[^܂Ƃ߂ĊǗ.
 * 
 * @author
 */
public class DataSet {
    private Logger logger = Logger.getLogger(DataSet.class.getName());
    private String name;

    private Vector dataSet = new Vector();

    private int domain_index = 0;

    /** uxɑΉf[^͉Ԗڂv\ */
    /**
     * Creates a new instance of DataSet
     * 
     * @param name
     *            the name of the dataset.
     */
    public DataSet(String name) {
        this.name = name;
    }

    private String fileName;

    /**
     * t@CZbg
     * 
     * @param fileName
     *            t@C
     */
    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    /**
     * t@CQbg
     * 
     * @return t@C
     */
    public String getFileName() {
        return this.fileName;
    }

    /**
     * uf[^Zbgvfvo^.
     * 
     * @param data
     *            o^ꎟf[^
     * @param identifier
     *            ̃f[^̎ʎq
     */
    public void addData(String[] data, String identifier) {
        DataSetElement d = new DataSetElement(data, identifier, this);
        dataSet.addElement(d);
    }

    /**
     * uf[^Zbgvfvo^.
     * 
     * @param dse
     *            o^uf[^ZbgGgv
     */
    public void addData(DataSetElement dse) {
        dataSet.addElement(dse);
    }

    /**
     * f[^̊evf̔zԂ. f[^o^ȏꍇnullԂ.
     * 
     * @return f[^̊evf̔z.
     */
    public DataSetElement[] getData() {
        if (dataSet == null || dataSet.size() == 0) {
            return null;
        }
        DataSetElement[] dse = new DataSetElement[dataSet.size()];
        dataSet.copyInto(dse);

        return dse;
    }

    /**
     * ̃f[^̖O擾.
     * 
     * @return ̃f[^̖O
     */
    public String getName() {
        return name;
    }

    /**
     * getNameƑSU镑.
     */
    public String toString() {
        return getName();
    }

}
