/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2006/02/23, 17:27
!  AUTHOR(S): KOGA, Junichiro
!  File : BZPanel.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.plugins.projectmanipulator.uvsorepsilon.preparationpanel;

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.JPanel;

import org.apache.log4j.Logger;

import ciss.phase_viewer.inputinterface.InputInterface;
import ciss.phase_viewer.plugins.projectmanipulator.phase.PhaseInputItems;
import ciss.phase_viewer.primitiveguis.ChoicePanelPhase;
import ciss.phase_viewer.projectbrowser.ProjectInfo;
import ciss.phase_viewer.projectbrowser.ProjectManipulator;

/**
 * 
 * @author
 */
public class BZPanel extends ProjectManipulator {
    private Logger logger = Logger.getLogger(GeneralPanel.class.getName());

    /** Creates a new instance of GeneralPanel */
    public BZPanel(ProjectInfo projectInfo) {
        super(projectInfo);
    }

    public void initializeProject() {
    }

    public void init() {
        setLayout(new BorderLayout());
        add(new SubPanel(projectInfo.getInputInterface()), BorderLayout.NORTH);
    }

    class SubPanel extends PhaseInputItems {
        SubPanel(InputInterface inputInterface) {
            super(inputInterface);
        }

        public void createGUI() {
            String[] specmethod = new String[] { "epsilon.BZ_integration.method" };
            String[] methodchoice = new String[] { "parabolic", "gaussian",
                    "tetrahedron" };
            ChoicePanelPhase method = new ChoicePanelPhase(specmethod,
                    inputInterface, "method", methodchoice, this);
            String[] specspin = new String[] { "epsilon.BZ_integration.spin" };
            String[] spinchoice = new String[] { "both", "major", "minor" };
            ChoicePanelPhase spin = new ChoicePanelPhase(specspin,
                    inputInterface, "spin", spinchoice, this);
            JPanel p = new JPanel();
            p.setLayout(new GridLayout(1, 2));
            p.add(method);
            p.add(spin);
            add(p);
        }

    }
}
