/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2005/11/02, 14:55
!  AUTHOR(S): KOGA, Junichiro
!  File : RedoAction.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.plugins.viewer.edit;

import java.awt.event.ActionEvent;

import org.apache.log4j.Logger;

import ciss.phase_viewer.acviewer.ACVAction;
import ciss.phase_viewer.acviewer.CoordsViewerInterface;
import ciss.phase_viewer.acviewer.MainPanel;

/**
 * 'redo' s߂̃ANV.
 * 
 * @author
 */
public class RedoAction extends ACVAction {
    private Logger logger = Logger.getLogger(RedoAction.class.getName());

    /** Creates a new instance of RedoAction */
    public RedoAction(MainPanel parent) {
        super(parent);
    }

    public void actionPerformed(ActionEvent e) {
        CoordsViewerInterface mp = (CoordsViewerInterface) parent;
        mp.getCD().getAtomCoords().saveState();
        if (mp.getCD().getAtomCoords().getAtomList().redo()) {
            mp.getCD().setCoords(mp.getCD().getAtomCoords());
        }
        mp.getCD().getAtomCoords().finalizeState();
    }

}
