/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2005/11/30, 14:34
!  AUTHOR(S): KOGA, Junichiro
!  File : BshConsole.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.scripting;

import org.apache.log4j.Logger;

import bsh.EvalError;
import bsh.Interpreter;
import bsh.util.JConsole;
import ciss.phase_viewer.mainpanel.InternalFrameChase;

/**
 * ``BeanShell''̃R\[N.
 * 
 * @author
 */
public class BshConsole extends InternalFrameChase {
    private Logger logger = Logger.getLogger(BshConsole.class.getName());

    /** Creates a new instance of BshConsole */
    public BshConsole() {
        super("bsh console", true, true, true, true, new java.awt.Dimension(
                500, 350));
        init();
    }

    public BshConsole(Interpreter interpreter) {

    }

    private void init() {
        JConsole console = new JConsole();
        Interpreter interpreter = new Interpreter(console);
        try {
            interpreter
                    .eval("importCommands(\"ciss.phase_viewer.scripting.commands\")");
        } catch (EvalError e) {
            e.printStackTrace();
        }
        interpreter.setExitOnEOF(false);
        new Thread(interpreter).start();
        getContentPane().add(console);
    }
}
